# Contributing to UriPoint

## Welcome Contributors!

We appreciate your interest in contributing to UriPoint, a Python video processing library.

## Getting Started

1. Fork the repository
2. Clone your fork
3. Create a new branch for your feature or bugfix

```bash
git checkout -b feature/your-feature-name
```

## Development Setup

1. Install development dependencies:
```bash
python -m venv venv
source venv/bin/activate
pip install -r requirements.txt
pip install -r requirements-dev.txt
```

2. Run tests:
```bash
python -m pytest
```

## Contribution Process

1. Make your changes
2. Write or update tests
3. Ensure all tests pass
4. Create a pull request with a clear description of your changes

## Code Style

- Follow PEP 8 guidelines
- Use type hints
- Write docstrings for all functions and classes
- Keep code clean and readable

## Reporting Issues

- Use GitHub Issues
- Provide a clear description
- Include steps to reproduce
- Share error messages and traceback if applicable

## Pull Request Process

1. Ensure your code passes all tests
2. Update documentation if needed
3. Add a description of your changes in the PR
4. Wait for code review

Thank you for contributing to UriPoint!
